#include "FileListConsts.au3"
#include "FileListFuncs.au3"

FileListDesktop()  ; Desktop
CloseDlls()
Exit

Func FileListDesktop()
  Local Const $CSIDL_DESKTOP = 0
  Local $pidlRel, $pIShellDesktop, $IShellDesktop, $pIEnumIDList, $IEnumIDList, $iFetched
  Local $tSTRRET = DllStructCreate( $tagSTRRET ), $sName, $sParsing

  ; Normal name and parsing name of the Desktop
  SHGetDesktopFolder( $pIShellDesktop )
  SHGetSpecialFolderLocation( $CSIDL_DESKTOP, $pidlRel )
  $IShellDesktop = ObjCreateInterface( $pIShellDesktop, $sIID_IShellFolder, $dtagIShellFolder )
  $IShellDesktop.GetDisplayNameOf( $pidlRel, $SHGDN_NORMAL, $tSTRRET )
  StrRetToBuf( DllStructGetPtr( $tSTRRET ), $NULL, $sName )
  $IShellDesktop.GetDisplayNameOf( $pidlRel, $SHGDN_FORPARSING, $tSTRRET )
  StrRetToBuf( DllStructGetPtr( $tSTRRET ), $NULL, $sParsing )
  ConsoleWrite( $sName & @CRLF )
  ConsoleWrite( $sParsing & @CRLF )
  CoTaskMemFree( $pidlRel )

  ; --- Print the name of the files ---

  ; Get an IEnumIDList interface pointer ($pIEnumIDList) for the enumeration object of the Desktop
  If $IShellDesktop.EnumObjects( $NULL, BitOR( $SHCONTF_NONFOLDERS, $SHCONTF_INCLUDEHIDDEN ), $pIEnumIDList ) = $S_OK Then
    ; Get the IEnumIDList interface
    $IEnumIDList = ObjCreateInterface( $pIEnumIDList, $sIID_IEnumIDList, $dtagIEnumIDList )
    ; Enumerate the files
    While $IEnumIDList.Next( 1, $pidlRel, $iFetched ) = $S_OK
      $IShellDesktop.GetDisplayNameOf( $pidlRel, $SHGDN_NORMAL, $tSTRRET )
      StrRetToBuf( DllStructGetPtr( $tSTRRET ), $NULL, $sName )
      ConsoleWrite( "    " & $sName & @CRLF )
      CoTaskMemFree( $pidlRel )
    WEnd
    $IEnumIDList = 0
  EndIf

  ; --- Print the name of the folders ---

  ; Get an IEnumIDList interface pointer ($pIEnumIDList) for the enumeration object of the Desktop
  If $IShellDesktop.EnumObjects( $NULL, BitOR( $SHCONTF_FOLDERS, $SHCONTF_INCLUDEHIDDEN ), $pIEnumIDList ) = $S_OK Then
    ; Get the IEnumIDList interface
    $IEnumIDList = ObjCreateInterface( $pIEnumIDList, $sIID_IEnumIDList, $dtagIEnumIDList )
    ; Enumerate the folders
    While $IEnumIDList.Next( 1, $pidlRel, $iFetched ) = $S_OK
      $IShellDesktop.GetDisplayNameOf( $pidlRel, $SHGDN_NORMAL, $tSTRRET )
      StrRetToBuf( DllStructGetPtr( $tSTRRET ), $NULL, $sName )
      ConsoleWrite( $sName & @CRLF )
      CoTaskMemFree( $pidlRel )
    WEnd
    $IEnumIDList = 0
  EndIf

  $IShellDesktop = 0
EndFunc
